// GeminiInternet.cpp: implementation of the CInternet class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GeminiInternet.h"
#include "GeminiRegistry.h"
#include <wininet.h>


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

// Access Code not in registry for security reasons.
CGeminiInternet::CGeminiInternet() 
{
	CGeminiRegistry reg;

	m_bInit=reg.GetURL(m_sGeminiURL);
	m_bInit=reg.GetUsername(m_sUsername);
	m_bInit=reg.GetAPIKey(m_sAPIKey);
	m_bInit=Encode(m_sUsername,m_sUsername);
	m_bInit=Encode(m_sAPIKey,m_sAPIKey);
}

CGeminiInternet::~CGeminiInternet()
{

}

bool CGeminiInternet::AssociateFile(wstring sFileName, wstring sPath,wstring sRepository,wstring sIssueID)
{
	wstring sURL,sTemp;
	if(!m_bInit)
		return false;
	
	HINTERNET hInternet=InternetOpen(L"Gemini VSS",PRE_CONFIG_INTERNET_ACCESS,NULL,INTERNET_INVALID_PORT_NUMBER,INTERNET_INVALID_PORT_NUMBER);
	
	MESSAGEBOX(NULL,"Gemini VSS - GI - AssociateFile","Associate 1",MB_OK);
	if(!hInternet)
	{
		MESSAGEBOX(NULL,"Gemini VSS - GI - AssociateFile","Associate 2",MB_OK);
		return false;
	}

	sURL=m_sGeminiURL;

	sURL+=L"?u=";
	sURL+=m_sUsername;

	sURL+=L"&a=";
	sURL+=m_sAPIKey;
	
	sURL+=L"&fn=";

	MESSAGEBOX(NULL,"Gemini VSS - GI - AssociateFile","Associate 3",MB_OK);
	if(!Encode(sFileName,sTemp))
		return false;

	sURL+=sTemp;

	sURL+=L"&fp=";

	MESSAGEBOX(NULL,"Gemini VSS - GI - AssociateFile","Associate 4",MB_OK);
	if(!Encode(sPath,sTemp))
		return false;

	sURL+=sTemp;

	sURL+=L"&scr=";

	MESSAGEBOX(NULL,"Gemini VSS - GI - AssociateFile","Associate 5",MB_OK);
	if(!Encode(sRepository,sTemp))
		return false;

	if(sTemp.substr(0,7)==L"file://")
		sTemp=sTemp.substr(7);
	sURL+=sTemp;

	sURL+=L"&ii=";

	sURL+=sIssueID;
	
	MESSAGEBOX(NULL,"Gemini VSS - GI - AssociateFile","Associate 6",MB_OK);
	if(m_sOldName.length()>0)
	{
		sURL+=L"&on=";
		if(!Encode(m_sOldName,sTemp))
			return false;

		sURL+=sTemp;
	}
	/*DWORD dw=1200;
	WCHAR *wchBuff=new WCHAR[dw+1];

	if(!wchBuff)
		return false;

	if(!InternetCanonicalizeUrl(s.c_str(),wchBuff,&dw,/*ICU_NO_META | 
        ICU_ENCODE_SPACES_ONLY *///0))
	/*{
		delete []wchBuff;
		return false;
	}
	
	s=wchBuff;

	delete []wchBuff;*/
	MESSAGEBOX(NULL,"Gemini VSS - GI - AssociateFile","Associate 7",MB_OK);
	HINTERNET hFile=InternetOpenUrl(hInternet,sURL.c_str(),NULL,0,INTERNET_FLAG_RELOAD,0);
	MESSAGEBOX(NULL,"Gemini VSS - GI - AssociateFile","Associate 8",MB_OK);
	if(!hFile)
		return false;

	CHAR chBuff2[999];
	DWORD dw=999;
	MESSAGEBOX(NULL,"Gemini VSS - GI - AssociateFile","Associate 9",MB_OK);
	BOOL b=InternetReadFile(hFile,chBuff2,dw,&dw);
	MESSAGEBOX(NULL,"Gemini VSS - GI - AssociateFile","Associate 10",MB_OK);
	chBuff2[dw]=NULL;
	MESSAGEBOX(NULL,chBuff2,"Associate 10.1",MB_OK);
	sURL=chBuff2[0];

	if(sURL!=L"0")
	{
		MessageBoxW(NULL,L"Gemini VSS - GI - AssociateFile 11",sURL.c_str(),MB_OK);
		return false;
	}
	MESSAGEBOX(NULL,"Gemini VSS - GI - AssociateFile","Associate 12",MB_OK);
	return true;
}

bool CGeminiInternet::Encode(const wstring &strIn,wstring &strOut)
{
	DWORD dwTemp=1200;
	WCHAR *wchBuff=new WCHAR[dwTemp+1];
	
	do 
	{
		if(!InternetCanonicalizeUrl(strIn.c_str(),wchBuff,&dwTemp,0))
		{
			delete []wchBuff;
			
			if(GetLastError()==ERROR_INSUFFICIENT_BUFFER)
			{
				// Buffer was too small, increase it.!
				wchBuff=new WCHAR[dwTemp+1];

				// Not enough memory... NEVER!
				if(!wchBuff)
					return false;
			}
			else
				return false;
		}
		else
			break;
	}
	while(TRUE);

	strOut=wchBuff;

	delete[]wchBuff;

	return true;
}

bool CGeminiInternet::AssociateFileWithIssues(wstring sFileName, wstring sPath, wstring sRepository, wstring sComment)
{
	vector<wstring>	issues;
	
	MESSAGEBOX(NULL,"Gemini VSS - GI - AssociateFileWithIssues","Associate 2.1",MB_OK);
	if(sComment.length()==0 && m_sOldName.length()>0)
	{
		AssociateFile(sFileName,sPath,sRepository,L"-999");
		return true;
	}
	else if(sComment.length()==0)
		return true;

	MESSAGEBOX(NULL,"Gemini VSS - GI - AssociateFileWithIssues","Associate 2.2",MB_OK);
	// Make sure we add a space to the end....
	sComment+=L" ";

	MESSAGEBOX(NULL,"Gemini VSS - GI - AssociateFileWithIssues","Associate 2.3",MB_OK);
	if(!SplitCommentToIssueIDs(sComment,issues))
		return false;

	MESSAGEBOX(NULL,"Gemini VSS - GI - AssociateFileWithIssues","Associate 2.4",MB_OK);
	for(vector<wstring>::iterator it=issues.begin();it!=issues.end();it++)
	{
		AssociateFile(sFileName,sPath,sRepository,*it);
	}
	MESSAGEBOX(NULL,"Gemini VSS - GI - AssociateFileWithIssues","Associate 2.5",MB_OK);

	return true;
}



bool CGeminiInternet::SplitCommentToIssueIDs(const wstring &sComment,vector<wstring> &issues)
{
	// Issues are specifid like this: GEM:issueid GEM:issueid etc...
	unsigned int uiFindFirst=sComment.find(L"GEM:");
	unsigned int uiFindNext;
	wstring sTmp;

	// Issues must be first!
	if(uiFindFirst!=0)
		return true;

	while(uiFindFirst!=-1)
	{
		uiFindNext=sComment.find(L" ",uiFindFirst);
		if(uiFindNext==-1)
			return true;

		sTmp=sComment.substr(uiFindFirst+4,uiFindNext-uiFindFirst-4);

		// Only add issue if it's a valid number!
		if(IsNumeric(sTmp))
			issues.push_back(sTmp);

		uiFindFirst=sComment.find(L"GEM:",uiFindNext);

		if(uiFindFirst-1!=uiFindNext)
			break;
	}

	return true;
}

bool CGeminiInternet::IsNumeric(const wstring &sCheck)
{
	for(wstring::const_iterator it=sCheck.begin();it!=sCheck.end();it++)
	{
		if(!isdigit(*it))
			return false;
	}

	return true;
}

void CGeminiInternet::SetOldName(wstring sOldName)
{
	m_sOldName=sOldName;
}
