// GeminiRegistry.cpp: implementation of the CGeminiRegistry class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GeminiRegistry.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGeminiRegistry::CGeminiRegistry():m_hRootKey(HKEY_LOCAL_MACHINE), m_sURLKeyName(L"GeminiURL"), m_sGeminiPageURL(L"LinkSourceControlFile"), 
	m_sUsernameKeyName(L"GeminiUsername"), m_sAPIKeyKeyName(L"GeminiAPIKey")
{
		
	if(RegOpenKey(m_hRootKey,L"SOFTWARE\\CounterSoft\\Gemini",&m_hGeminiKey)!=ERROR_SUCCESS)
		m_hGeminiKey=NULL;
	
}

CGeminiRegistry::~CGeminiRegistry()
{
	if(m_hGeminiKey)
		RegCloseKey(m_hGeminiKey);
}

bool CGeminiRegistry::GetURL(wstring &sURL)
{
	WCHAR wchVal[1000];
	DWORD lLen=999;
	
	if(m_hGeminiKey)
	{
		if(RegQueryValueEx(m_hGeminiKey,m_sURLKeyName.c_str(),NULL,NULL,reinterpret_cast<LPBYTE>(wchVal),&lLen)!=ERROR_SUCCESS)
			return false;	

		sURL=wchVal;

		/*lLen=999;
		if(RegQueryValueEx(m_hGeminiKey,m_sGeminiPageURL.c_str(),NULL,NULL,reinterpret_cast<LPBYTE>(wchVal),&lLen)!=ERROR_SUCCESS)
			return false;	

		sURL+=L"/";
		sURL+=wchVal;*/

		return true;
	}

	return false;
	
}

bool CGeminiRegistry::GetUsername(wstring &sUsername)
{
	WCHAR wchVal[1000];
	DWORD lLen=999;
	
	if(m_hGeminiKey)
	{
		if(RegQueryValueEx(m_hGeminiKey,m_sUsernameKeyName.c_str(),NULL,NULL,reinterpret_cast<LPBYTE>(wchVal),&lLen)!=ERROR_SUCCESS)
			return false;	

		sUsername = wchVal;

		return true;
	}

	return false;
	
}

bool CGeminiRegistry::GetAPIKey(wstring &sAPIKey)
{
	WCHAR wchVal[1000];
	DWORD lLen=999;
	
	if(m_hGeminiKey)
	{
		if(RegQueryValueEx(m_hGeminiKey,m_sAPIKeyKeyName.c_str(),NULL,NULL,reinterpret_cast<LPBYTE>(wchVal),&lLen)!=ERROR_SUCCESS)
			return false;	

		sAPIKey = wchVal;

		return true;
	}

	return false;
	
}
