// SourceSafe.cpp : Implementation of CSourceSafe
#include "stdafx.h"
#include "GeminiVSS.h"
#include "SourceSafe.h"

/////////////////////////////////////////////////////////////////////////////
// CSourceSafe

STDMETHODIMP CSourceSafe::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_ISourceSafe
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

bool CSourceSafe::AssociateFileWithIssues(IVSSItem *pIItem, BSTR sComment, BSTR sOldName)
{
	MESSAGEBOX(NULL,"Gemini VSS - AssociateFileWithIssues","Associate 1",MB_OK);
	BSTR sName,sPath; 
	IVSSItem *iParent=NULL;
	
    if(sComment == NULL)
        sComment = L"";

	pIItem->get_Parent(&iParent);
	
	if(iParent)
	{
		iParent->get_Spec(&sPath);
		iParent->Release();
	}
	else
		pIItem->get_Spec(&sPath);
	

	pIItem->get_Name(&sName);

	
	CGeminiInternet gi;

	if(sOldName)
		gi.SetOldName(sOldName);

    long lVersion;
    WCHAR sVersion[11];
    pIItem->get_VersionNumber(&lVersion);
    wsprintf(sVersion, L"%li", lVersion);
    wstring sNameAndVersion(sName);
    sNameAndVersion += ';';
    sNameAndVersion += sVersion;

	MESSAGEBOX(NULL,"Gemini VSS - AssociateFileWithIssues","Associate 2",MB_OK);
	bool bRet=gi.AssociateFileWithIssues(sNameAndVersion,sPath,m_sINIFile,sComment);
	MESSAGEBOX(NULL,"Gemini VSS - AssociateFileWithIssues","Associate 3",MB_OK);
	SysFreeString(sName);
	SysFreeString(sPath);

	return bRet;
}
